unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, Buttons;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    Executar1: TMenuItem;
    Abrirarquivodata1: TMenuItem;
    Abrirarquivotest1: TMenuItem;
    N1: TMenuItem;
    Sair1: TMenuItem;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    Classificar1: TMenuItem;
    CheckBox1: TCheckBox;
    Edit3: TEdit;
    Label5: TLabel;
    Ajuda1: TMenuItem;
    Sobre1: TMenuItem;
    Fechar1: TMenuItem;
    procedure Fechar1Click(Sender: TObject);
    procedure Sobre1Click(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Abrirarquivonames1Click(Sender: TObject);
    procedure Abrirarquivodata1Click(Sender: TObject);
    procedure Abrirarquivotest1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Executar1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Classificar1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure Ajuda1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure inicializar; forward;
procedure finalizar; forward;
procedure finalizar_teste; forward;
procedure ler_instancias_treino(nome_arquivo: string); forward;
procedure ler_instancias_teste(nome_arquivo: string); forward;
procedure cross_validate; forward;
procedure gerar_saida; forward;

type bloco_atributo = record  //para armazenamento dos atributos de uma instncia de aprendizado
                      atributo: string;
                      prox: Pointer;
                      end;

type bloco_instancia = record //para armazenamento das instncias de aprendizado
                       atributo: Pointer;
                       classe: string;
                       prox: Pointer;
                       end;

type bloco_probabilidade_classe = record //para armazenamento de todas as probabilidades possveis P(classe)
                                  classe: string;
                                  valor: real;
                                  prox: Pointer;
                                  end;

type bloco_probabilidade_atributo = record //para armazenamento de todas as probabilidades possveis P(atributo=valor|classe)
                                    atributo: string;
                                    classe: string;
                                    valor: real;
                                    prox: Pointer;
                                    end;

type bloco_instancia_teste = record
                              atributo: Pointer;
                              classe: string;
                              predicoes: Pointer; //todas as possveis classes e suas probabilidades
                              predicao: string; //classe escolhida dentre "predicoes"
                              prob_pred: real; //probabilidade da classe em "predicao" ocorrer
                              prox: Pointer;
                              end;

var
  MainForm: TMainForm;
  patributo, auxatributo: ^bloco_atributo;
  pinstancia, iniinstancia, fiminstancia: ^bloco_instancia;
  pprobatr, iniprobatr, fimprobatr: ^bloco_probabilidade_atributo;
  pprobcla, iniprobcla, fimprobcla, auxprobcla, aux1probcla: ^bloco_probabilidade_classe;
  pteste, initeste, fimteste: ^bloco_instancia_teste;
  n_atr, n_inst, n_teste: integer;
  primeira_rodada: boolean;

implementation

uses Sobre, Ajuda;

{$R *.dfm}

procedure TMainForm.Fechar1Click(Sender: TObject);
begin
        finalizar;
        Close;
end;

procedure TMainForm.Sobre1Click(Sender: TObject);
begin
        SobreForm.ShowModal;
end;

procedure TMainForm.Sair1Click(Sender: TObject);
begin
        finalizar;
        Close;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
        if (OpenDialog1.Execute)
          then Edit1.Text:=OpenDialog1.FileName;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
        if (OpenDialog1.Execute)
          then Edit2.Text:=OpenDialog1.FileName;
end;

procedure TMainForm.Abrirarquivonames1Click(Sender: TObject);
begin
        MainForm.Button1Click(self);
end;

procedure TMainForm.Abrirarquivodata1Click(Sender: TObject);
begin
        MainForm.Button1Click(self);
end;

procedure TMainForm.Abrirarquivotest1Click(Sender: TObject);
begin
        MainForm.Button2Click(self);
end;

procedure inicializar;
begin
        MainForm.Caption:='Inicializando...';
        MainForm.Repaint;

        patributo:=nil;
        auxatributo:=nil;
        pinstancia:=nil;
        iniinstancia:=nil;
        fiminstancia:=nil;
        pprobatr:=nil;
        iniprobatr:=nil;
        fimprobatr:=nil;
        pprobcla:=nil;
        iniprobcla:=nil;
        fimprobcla:=nil;
        auxprobcla:=nil;
        aux1probcla:=nil;
        pteste:=nil;
        initeste:=nil;
        fimteste:=nil;
        n_atr:=0;
        n_inst:=0;
        n_teste:=0;
end;

procedure finalizar;
begin
        MainForm.Caption:='Finalizando...';
        MainForm.Repaint;

        fiminstancia:=nil;
        pinstancia:=iniinstancia;
        while (pinstancia<>nil) do
          begin
          patributo:=pinstancia.atributo;
          while (patributo<>nil) do
            begin
            auxatributo:=patributo.prox;
            dispose(patributo);
            patributo:=auxatributo;
            end;
          iniinstancia:=iniinstancia.prox;
          dispose(pinstancia);
          pinstancia:=iniinstancia;
          end;

        fimprobatr:=nil;
        pprobatr:=iniprobatr;
        while (pprobatr<>nil) do
          begin
          iniprobatr:=iniprobatr.prox;
          dispose(pprobatr);
          pprobatr:=iniprobatr;
          end;

        fimprobcla:=nil;
        pprobcla:=iniprobcla;
        while (pprobcla<>nil) do
          begin
          iniprobcla:=iniprobcla.prox;
          dispose(pprobcla);
          pprobcla:=iniprobcla;
          end;

        finalizar_teste;
end;

procedure finalizar_teste;
begin
        fimteste:=nil;
        pteste:=initeste;
        while (pteste<>nil) do
          begin
          patributo:=pteste.atributo;
          while (patributo<>nil) do
            begin
            auxatributo:=patributo.prox;
            dispose(patributo);
            patributo:=auxatributo;
            end;
          pprobcla:=pteste.predicoes;
          while (pprobcla<>nil) do
            begin
            auxprobcla:=pprobcla.prox;
            dispose(pprobcla);
            pprobcla:=auxprobcla;
            end;
          initeste:=initeste.prox;
          dispose(pteste);
          pteste:=initeste;
          end;
end;

procedure ler_instancias_treino(nome_arquivo: string);
var st, atr: string;
    c: char;
    i, contador: integer;
    arq: TextFile;
    primeira_vez, achou: boolean;
begin
        MainForm.Caption:='Treinando...';
        MainForm.Repaint;

        AssignFile(arq,nome_arquivo);
        Reset(arq);

        read(arq,c);
        while (not(((c>='a') and (c<='z')) or ((c>='A') and (c<='Z')) or ((c>='0') and (c<='9')))) do
          read(arq,c);

        primeira_vez:=True;

        while (not(EOF(arq))) do
          begin

          st:='';
          while (c<>'.') do
            begin
            st:=st+c;
            read(arq,c);
            end;
          st:=st+c;

          new(pinstancia);
          pinstancia.atributo:=nil;
          pinstancia.prox:=nil;
          if (iniinstancia=nil)
            then iniinstancia:=pinstancia
            else fiminstancia.prox:=pinstancia;
          fiminstancia:=pinstancia;
          n_inst:=n_inst+1;

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          atr:='';
          for i:=1 to length(st) do
            begin
            if ((st[i]=',') and (st[i+1]=' '))
              then begin
                   //cria novo atributo da instncia
                   new(patributo);
                   patributo.atributo:=atr;
                   patributo.prox:=nil;
                   if (auxatributo<>nil)
                     then auxatributo.prox:=patributo
                     else pinstancia.atributo:=patributo;
                   auxatributo:=patributo;
                   patributo:=nil;
                   if (primeira_vez=True)
                     then n_atr:=n_atr+1;
                   atr:='';

                   MainForm.BitBtn1.Caption:=TimeToStr(Time);
                   MainForm.Repaint;

                   end
              else if (st[i]='.')
                     then begin
                          pinstancia.classe:=atr;
                          atr:='';

                          //registra valores na lista de probabilidades de P(classe)

                          achou:=False;
                          pprobcla:=iniprobcla;
                          while ((pprobcla<>nil) and (achou=False)) do
                            begin
                            if (pprobcla.classe=pinstancia.classe)
                              then begin
                                   achou:=True;
                                   pprobcla.valor:=pprobcla.valor+1;
                                   end
                              else pprobcla:=pprobcla.prox;
                            end;
                          if (pprobcla<>nil)
                            then pprobcla:=nil;
                          if (achou=False)
                            then begin
                                 new(pprobcla);
                                 pprobcla.classe:=pinstancia.classe;
                                 pprobcla.valor:=1;;
                                 pprobcla.prox:=nil;
                                 if (iniprobcla=nil)
                                   then iniprobcla:=pprobcla
                                   else fimprobcla.prox:=pprobcla;
                                 fimprobcla:=pprobcla;
                                 pprobcla:=nil;
                                 end;

                          MainForm.BitBtn1.Caption:=TimeToStr(Time);
                          MainForm.Repaint;

                          //registra valores na lista de probabilidades de P(atributo=valor|classe)
                          patributo:=pinstancia.atributo;
                          contador:=1;
                          while (patributo<>nil) do
                            begin

                            achou:=False;
                            pprobatr:=iniprobatr;
                            while ((pprobatr<>nil) and (achou=False)) do
                              begin
                              if ((pprobatr.atributo=IntToStr(contador)+'='+patributo.atributo) and (pprobatr.classe=pinstancia.classe))
                                then begin
                                     achou:=True;
                                     pprobatr.valor:=pprobatr.valor+1;
                                     end
                                else pprobatr:=pprobatr.prox;
                              end;
                            if (pprobatr<>nil)
                              then pprobatr:=nil;
                            if (achou=False)
                              then begin
                                   new(pprobatr);
                                   pprobatr.atributo:=IntToStr(contador)+'='+patributo.atributo;
                                   pprobatr.classe:=pinstancia.classe;
                                   pprobatr.valor:=1;
                                   pprobatr.prox:=nil;
                                   if (iniprobatr=nil)
                                     then iniprobatr:=pprobatr
                                     else fimprobatr.prox:=pprobatr;
                                   fimprobatr:=pprobatr;
                                   pprobatr:=nil;
                                   end;

                            patributo:=patributo.prox;
                            contador:=contador+1;

                            MainForm.BitBtn1.Caption:=TimeToStr(Time);
                            MainForm.Repaint;

                            end;

                          end
                     else if (((st[i]>='a') and (st[i]<='z')) or ((st[i]>='A') and (st[i]<='Z')) or ((st[i]>='0') and (st[i]<='9')) or (st[i]=','))
                            then atr:=atr+st[i];
            end;

          primeira_vez:=False;

          read(arq,c);
          while ((not(EOF(arq))) and (not(((c>='a') and (c<='z')) or ((c>='A') and (c<='Z')) or ((c>='0') and (c<='9'))))) do
            read(arq,c);

          auxatributo:=nil;
          pinstancia:=nil;

          end;

        CloseFile(arq);

        //atualizando listas de probabilidades
        pprobatr:=iniprobatr;
        while (pprobatr<>nil) do
          begin

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          achou:=False;
          pprobcla:=iniprobcla;
          while (achou=False) do
            begin
            if (pprobcla.classe=pprobatr.classe)
              then begin
                   achou:=True;
                   pprobatr.valor:=pprobatr.valor/pprobcla.valor;
                   end
              else pprobcla:=pprobcla.prox;
            end;
          pprobatr:=pprobatr.prox;
          end;
        pprobcla:=iniprobcla;
        while (pprobcla<>nil) do
          begin
          pprobcla.valor:=pprobcla.valor/n_inst;
          pprobcla:=pprobcla.prox;
          end;
end;

procedure ler_instancias_teste(nome_arquivo: string);
var st, atr: string;
    c: char;
    i, contador: integer;
    normalizador: real;
    arq: TextFile;
    achou: boolean;
begin
        MainForm.Caption:='Testando...';
        MainForm.Repaint;

        AssignFile(arq,nome_arquivo);
        Reset(arq);

        read(arq,c);
        while (not(((c>='a') and (c<='z')) or ((c>='A') and (c<='Z')) or ((c>='0') and (c<='9')))) do
          read(arq,c);

        while (not(EOF(arq))) do
          begin

          st:='';
          while (c<>'.') do
            begin
            st:=st+c;
            read(arq,c);
            end;
          st:=st+c;

          new(pteste);
          pteste.predicoes:=nil;
          pteste.predicao:='';
          pteste.prob_pred:=-1;
          pteste.prox:=nil;
          if (initeste=nil)
            then initeste:=pteste
            else fimteste.prox:=pteste;
          fimteste:=pteste;
          n_teste:=n_teste+1;

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          atr:='';
          for i:=1 to length(st) do
            begin
            if ((st[i]=',') and (st[i+1]=' '))
              then begin
                   //cria novo atributo da instncia de teste
                   new(patributo);
                   patributo.atributo:=atr;
                   patributo.prox:=nil;
                   if (auxatributo<>nil)
                     then auxatributo.prox:=patributo
                     else pteste.atributo:=patributo;
                   auxatributo:=patributo;
                   patributo:=nil;
                   atr:='';

                   MainForm.BitBtn1.Caption:=TimeToStr(Time);
                   MainForm.Repaint;

                   end
              else if (st[i]='.')
                     then begin
                          pteste.classe:=atr;
                          atr:='';
                          end
                     else if (((st[i]>='a') and (st[i]<='z')) or ((st[i]>='A') and (st[i]<='Z')) or ((st[i]>='0') and (st[i]<='9')) or (st[i]=','))
                            then atr:=atr+st[i];
            end;

          read(arq,c);
          while ((not(EOF(arq))) and (not(((c>='a') and (c<='z')) or ((c>='A') and (c<='Z')) or ((c>='0') and (c<='9'))))) do
            read(arq,c);

          auxatributo:=nil;
          pteste:=nil;

          end;

        CloseFile(arq);

        //calculando classes e suas probabilidades para as instncias de teste
        pteste:=initeste;
        while (pteste<>nil) do
          begin

          normalizador:=0;

          //para cada classe
          pprobcla:=iniprobcla;
          while (pprobcla<>nil) do
            begin

            MainForm.BitBtn1.Caption:=TimeToStr(Time);
            MainForm.Repaint;

            new(auxprobcla);
            auxprobcla.classe:=pprobcla.classe;
            auxprobcla.valor:=1;
            auxprobcla.prox:=nil;
            if (aux1probcla=nil)
              then pteste.predicoes:=auxprobcla
              else aux1probcla.prox:=auxprobcla;
            aux1probcla:=auxprobcla;

            //para cada atributo
            patributo:=pteste.atributo;
            contador:=1;
            while (patributo<>nil) do
              begin

              //verificando lista de probabilidades de P(atributo=valor|classe)
              achou:=False;
              pprobatr:=iniprobatr;
              while ((pprobatr<>nil) and (achou=False)) do
                begin
                if ((pprobatr.atributo=IntToStr(contador)+'='+patributo.atributo) and (pprobatr.classe=auxprobcla.classe))
                  then begin
                       achou:=True;
                       auxprobcla.valor:=auxprobcla.valor*pprobatr.valor;
                       end
                  else pprobatr:=pprobatr.prox;
                end;

              if (achou=False)
                then auxprobcla.valor:=auxprobcla.valor*0;

              patributo:=patributo.prox;
              contador:=contador+1;
              end;

            auxprobcla.valor:=auxprobcla.valor*pprobcla.valor;
            normalizador:=normalizador+auxprobcla.valor;

            //procurando a classe com maior probabilidade
            if (auxprobcla.valor>pteste.prob_pred)
              then begin
                   pteste.predicao:=auxprobcla.classe;
                   pteste.prob_pred:=auxprobcla.valor;
                   end;

            auxprobcla:=nil;

            pprobcla:=pprobcla.prox;
            end;

          aux1probcla:=nil;

          //normalizando as probabilidades das classes
          if (normalizador<>0)
            then pteste.prob_pred:=pteste.prob_pred/normalizador;
          auxprobcla:=pteste.predicoes;
          while (auxprobcla<>nil) do
            begin
            if (normalizador<>0)
              then auxprobcla.valor:=auxprobcla.valor/normalizador;
            auxprobcla:=auxprobcla.prox;
            end;

          pteste:=pteste.prox;
          end;
end;

procedure gerar_saida;
var arq: TextFile;
    contador: integer;
begin
        MainForm.Caption:='Gerando arquivo de sada...';
        MainForm.Repaint;

        AssignFile(arq,'saida.txt');
        Rewrite(arq);

        write(arq,'Nmero de atributos de cada instncia: '+FloatToStr(n_atr)+#13+#10+#13+#10);

        write(arq,'=================================================='+#13+#10+#13+#10);

        write(arq,'Nmero de instncias do conjunto de treinamento: '+FloatToStr(n_inst)+#13+#10+#13+#10);

        write(arq,'=================================================='+#13+#10+#13+#10);

        write(arq,'Conjunto de treinamento:'+#13+#10+#13+#10);
        pinstancia:=iniinstancia;
        while (pinstancia<>nil) do
          begin
          patributo:=pinstancia.atributo;
          while (patributo<>nil) do
            begin
            write(arq,patributo.atributo+' ');
            patributo:=patributo.prox;
            end;
          write(arq,pinstancia.classe);
          write(arq,#13+#10);
          pinstancia:=pinstancia.prox;

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          end;
        write(arq,#13+#10);

        write(arq,'=================================================='+#13+#10+#13+#10);

        write(arq,'Probabilidade das classes: '+#13+#10+#13+#10);
        pprobcla:=iniprobcla;
        while (pprobcla<>nil) do
          begin
          write(arq,'Classe '+pprobcla.classe+': '+FloatToStr(pprobcla.valor)+#13+#10);
          pprobcla:=pprobcla.prox;

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          end;
        write(arq,#13+#10);

        write(arq,'=================================================='+#13+#10+#13+#10);

        write(arq,'Probabilidade condicionais: '+#13+#10+#13+#10);
        pprobatr:=iniprobatr;
        while (pprobatr<>nil) do
          begin
          write(arq,'Atributo '+pprobatr.atributo+'|Classe='+pprobatr.classe+': '+FloatToStr(pprobatr.valor)+#13+#10);
          pprobatr:=pprobatr.prox;

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          end;
        write(arq,#13+#10);

        write(arq,'=================================================='+#13+#10+#13+#10);

        write(arq,'Nmero de instncias do conjunto de teste: '+FloatToStr(n_teste)+#13+#10+#13+#10);

        write(arq,'=================================================='+#13+#10+#13+#10);

        write(arq,'Conjunto de teste com predies:'+#13+#10+#13+#10);
        pteste:=initeste;
        while (pteste<>nil) do
          begin

          patributo:=pteste.atributo;
          while (patributo<>nil) do
            begin
            write(arq,patributo.atributo+' ');
            patributo:=patributo.prox;
            end;
          write(arq,pteste.classe);
          write(arq,#13+#10);

          pprobcla:=pteste.predicoes;
          while (pprobcla<>nil) do
            begin
            write(arq,'Classe '+pprobcla.classe+': '+FloatToStr(pprobcla.valor)+#13+#10);
            pprobcla:=pprobcla.prox;
            end;
          write(arq,'Classe escolhida: '+pteste.predicao+' com probabilidade '+FloatToStr(pteste.prob_pred)+#13+#10+#13+#10);

          pteste:=pteste.prox;

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          end;

        write(arq,'=================================================='+#13+#10+#13+#10);

        if (n_teste>0)
          then begin
               contador:=0;
               pteste:=initeste;
               while (pteste<>nil) do
                 begin
                 if (pteste.classe<>pteste.predicao)
                   then contador:=contador+1;
                 pteste:=pteste.prox;

                 MainForm.BitBtn1.Caption:=TimeToStr(Time);
                 MainForm.Repaint;

                 end;
               write(arq,'Taxa de erro do classificador: '+FloatToStr(contador/n_teste));
               end;

        CloseFile(arq);
end;

procedure TMainForm.Executar1Click(Sender: TObject);
begin
        MainForm.BitBtn1Click(self);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
        primeira_rodada:=True;
        MainMenu1.Items[2].Enabled:=False;
        CheckBox1.Checked:=False;
        Edit3.Enabled:=False;
        Edit3.Visible:=False;
        Label5.Visible:=False;
end;

procedure TMainForm.Classificar1Click(Sender: TObject);
var i: integer;
    arq: TextFile;
    resp, st: string;
begin
        n_teste:=0;
        st:='_$temp$_.tmp';

        AssignFile(arq,st);
        Rewrite(arq);

        for i:=1 to n_atr do
          begin
          resp:=InputBox('Classificao de nova instncia','Entre com o atributo '+IntToStr(i),'');
          write(arq,resp+', ');
          end;
        write(arq,'Classe.');

        CloseFile(arq);

        finalizar_teste;
        ler_instancias_teste(st);
        gerar_saida;
        Memo1.Clear;
        Memo1.Lines.LoadFromFile('saida.txt');

        AssignFile(arq,st);
        Erase(arq);

        MainForm.Caption:='Naive-Bayes';
        MainForm.BitBtn1.Caption:='Executar';
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        finalizar;
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
begin
        if (CheckBox1.Checked=False)
          then begin
               Edit3.Enabled:=False;
               Edit3.Visible:=False;
               Label5.Visible:=False;
               end
          else begin
               Edit3.Enabled:=True;
               Edit3.Visible:=True;
               Label5.Visible:=True;
               end;
end;

procedure cross_validate;
var k, i, conta_inst, contador, contaponto, tam_fold: integer;
    erro: real;
    arq, arqtreino, arqteste, arqsaida: TextFile;
    c: char;
    st_treino, st_teste: string;
begin
        MainForm.MainMenu1.Items[2].Enabled:=False; //desabilitando menu

        //estabelecendo nomes de arquivos temporrios para o processo de cross-validation
        st_treino:='_$temp$_treino.tmp';
        st_teste:='_$temp$_teste.tmp';

        //capturando nmero de folds
        k:=StrToInt(MainForm.Edit3.Text);

        //contando quantas instncias h
        AssignFile(arq,MainForm.Edit1.Text);
        Reset(arq);
        while (not(EOF(arq))) do
          begin

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          read(arq,c);
          if (c='.')
            then n_inst:=n_inst+1;
          end;
        CloseFile(arq);

        //calculando quantas instncias h em cada fold
        tam_fold:=n_inst div k;

        MainForm.Caption:='Gerando arquivo de sada...';
        MainForm.Repaint;

        AssignFile(arqsaida,'saida.txt');
        Rewrite(arqsaida);

        write(arqsaida,'Cross-validation com '+IntToStr(k)+' folds:'+#13+#10+#13+#10);
        write(arqsaida,'Nmero de instncias: ',IntToStr(n_inst)+#13+#10);
        write(arqsaida,'Nmero de instncias mdio por fold: ',IntToStr(tam_fold)+#13+#10+#13+#10);
        write(arqsaida,'=================================================='+#13+#10+#13+#10);
        write(arqsaida,'Taxas de erro por fold:'+#13+#10+#13+#10);

        //separando os folds e executando o classificador
        erro:=0;
        for i:=1 to k do
          begin

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          if (i>1)
            then begin
                 finalizar;
                 inicializar;
                 end;

          AssignFile(arq,MainForm.Edit1.Text); //arquivo original
          Reset(arq);
          AssignFile(arqtreino,st_treino); //novo arquivo de treino com k-1 folds
          Rewrite(arqtreino);
          AssignFile(arqteste,st_teste); //novo arquivo de teste com 1 fold
          Rewrite(arqteste);

          contaponto:=0;
          while (not(EOF(arq))) do
            begin

            MainForm.BitBtn1.Caption:=TimeToStr(Time);
            MainForm.Repaint;

            read(arq,c);
            if (i<k)
              then begin
                   if ((contaponto>=(i-1)*tam_fold) and (contaponto<i*tam_fold))
                     then write(arqteste,c)
                     else write(arqtreino,c);
                   if (c='.')
                     then contaponto:=contaponto+1;
                   end
              else begin
                   if (contaponto>=(i-1)*tam_fold)
                     then write(arqteste,c)
                     else write(arqtreino,c);
                   if (c='.')
                     then contaponto:=contaponto+1;
                   end;
            end;

          CloseFile(arqteste);
          CloseFile(arqtreino);
          CloseFile(arq);

          //treino e teste com os novos arquivos
          ler_instancias_treino(st_treino);
          ler_instancias_teste(st_teste);

          //clculo do erro
          conta_inst:=0;
          contador:=0;
          pteste:=initeste;
          while (pteste<>nil) do
            begin
            conta_inst:=conta_inst+1;
            if (pteste.classe<>pteste.predicao)
              then contador:=contador+1;
            pteste:=pteste.prox;
            end;

          MainForm.BitBtn1.Caption:=TimeToStr(Time);
          MainForm.Repaint;

          erro:=erro+(contador/conta_inst);

          write(arqsaida,'Fold '+IntToStr(i)+': '+FloatToStr(contador/conta_inst)+#13+#10);

          end;

        AssignFile(arqtreino,st_treino);
        Erase(arqtreino);
        AssignFile(arqteste,st_teste);
        Erase(arqteste);

        erro:=erro/k;

        write(arqsaida,#13+#10);
        write(arqsaida,'=================================================='+#13+#10+#13+#10);
        write(arqsaida,'Taxa de erro mdia: '+FloatToStr(erro));
        CloseFile(arqsaida);
        MainForm.Memo1.Clear;
        MainForm.Memo1.Lines.LoadFromFile('saida.txt');
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
        MainForm.BitBtn1.Caption:=TimeToStr(Time);
        MainForm.Repaint;

        if (primeira_rodada=True)
          then primeira_rodada:=False
          else finalizar;
        inicializar;

        if (CheckBox1.Checked=False) //sem cross-validate
          then begin
               if (Edit1.Text<>'')
                 then ler_instancias_treino(Edit1.Text);
               if ((Edit1.Text<>'') and (Edit2.Text<>''))
                 then ler_instancias_teste(Edit2.Text);
               gerar_saida;
               Memo1.Lines.LoadFromFile('saida.txt');
               MainMenu1.Items[2].Enabled:=True;
               end
          else if ((Edit1.Text<>'') and (StrToInt(Edit3.Text)>1))//cross-validate com k folds
                 then cross_validate;

        MainForm.BitBtn1.Caption:='Executar';

        MainForm.Caption:='Naive-Bayes';
end;

procedure TMainForm.Ajuda1Click(Sender: TObject);
begin
        HelpForm.ShowModal;
end;

end.
